; ##############################################################################
; ##############################################################################
; ##############################################################################
; CS02 CS01 CS00 Description													
; 0 0 0 No clock source (timer/counter stopped)									
; 0 0 1 clkI/O/(no prescaling)													
;*0 1 0 clkI/O/8 (from prescaler)												
; 0 1 1 clkI/O/64 (from prescaler)												
; 1 0 0 clkI/O/256 (from prescaler)												
; 1 0 1 clkI/O/1024 (from prescaler)											
; 1 1 0 External clock source on T0 pin. Clock on falling edge.					
; 1 1 1 External clock source on T0 pin. Clock on rising edge.					
TIMER0_INITIALISIEREN:
	ldi temp,(1<<TOIE0)
	STS(TIMSK0),temp
	ldi temp,(0<<CS02)|(1<<CS01) |(0<<CS00) 
	OUT(TCCR0A),temp
;	ldi temp,127
;	OUT(TCNT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 2ms																			
TIM0_OVF:
	in KOPIE_SREG,SREG			; SREG sichern					
	movw KOPIE_temp,temp		; temp + temp1 sichern (movw) 	
; ------------------------------------------------------------------------------
; LED																			
; ------------------------------------------------------------------------------
	sbi (LED_PORT),(LED_PIN_NR)				; LED off 	
	sbic (MOTOR_AUF_PIN),(MOTOR_AUF_PIN_NR)	; Skip if Bit in I/O Register is Set	
	cbi (LED_PORT),(LED_PIN_NR)				; LED on 	
	sbic (MOTOR_ZU_PIN),(MOTOR_ZU_PIN_NR)	; Skip if Bit in I/O Register is Set	
	cbi (LED_PORT),(LED_PIN_NR)				; LED on 	
; ------------------------------------------------------------------------------
; MOTOR-LAUFZEIT																
; ------------------------------------------------------------------------------
	LDS temp,(adr_MOTOR_DREHRICHTUNG)	; Drehrichtung	
	tst temp			
	breq TIM0_OVF_MOTOR_LZ_FERTSCH_A	; Motor steht	
	dec LZ								; -1			
	tst LZ								; Null ?		
	brne TIM0_OVF_MOTOR_LZ_FERTSCH_B	; nein			
; ------------------------------------------------------------------------------
;  berschritten, alles STOP !!!												
	STS(adr_MOTOR_DREHRICHTUNG),NULL	
	call MOTOR_STOP
	call MOTOR_REFLEXLICHTSCHRANKE_OFF
TIM0_OVF_MOTOR_LZ_FERTSCH_A:
	mov LZ,NULL							; Laufeit volle Pulle !
TIM0_OVF_MOTOR_LZ_FERTSCH_B:
; ------------------------------------------------------------------------------
; DREHGEBER																		
; ------------------------------------------------------------------------------
; Kanal-A-B abfragen															
	SEC  				; Set Carry
	sbis (DREH_A_PIN),(DREH_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	CLC  				; Clear Carry
	ROL DREHGEBER_ROHBITS	; links Carry
	SEC  				; Set Carry
	sbis (DREH_B_PIN),(DREH_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	CLC  				; Clear Carry
	ROL DREHGEBER_ROHBITS
; ------------------------------------------------------------------------------
	mov temp,DREHGEBER_ROHBITS
	cpi temp,0b00000000	; 0x00
	breq TIM0_DREH_OK
	cpi temp,0b10101010	; 0XAA
	breq TIM0_DREH_OK
	cpi temp,0b01010101	; 0x55
	breq TIM0_DREH_OK
	cpi temp,0b11111111	; 0xFF
	breq TIM0_DREH_OK
	rjmp TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
TIM0_DREH_OK:
	cp DREHGEBER_ROHBITS,DREHGEBER_WERT_OLD	; Vergleich	
	breq TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
	mov DREHGEBER_WERT_OLD,DREHGEBER_ROHBITS
	LSR DREHGEBER_ROHBITS	; C kullert raus	
	ROL DREHGEBER_BITMUSTER ; C reinscheiben	
	LSR DREHGEBER_ROHBITS	; C kullert raus	
	ROL DREHGEBER_BITMUSTER ; C reinscheiben	
	mov temp,DREHGEBER_BITMUSTER
	andi temp,0b00111111	; begrenzen			
	cpi temp,0x0B
	breq TIM0_OVF_RICHTUNG_1
	cpi temp,0x34
	breq TIM0_OVF_RICHTUNG_1
	cpi  temp,0x07
	breq TIM0_OVF_RICHTUNG_2
	cpi  temp,0x38
	breq TIM0_OVF_RICHTUNG_2
	rjmp TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
TIM0_OVF_RICHTUNG_1:
	STS(adr_DREHGEBER_WERT),EINS
	rjmp TIM0_DREH_FERTIG
TIM0_OVF_RICHTUNG_2:
	STS(adr_DREHGEBER_WERT),VOLL
TIM0_DREH_FERTIG:
; ------------------------------------------------------------------------------
; MOTOR																			
; ------------------------------------------------------------------------------
;.equ MOTOR_ABTASTUNG= 0b00001111	; langsamer Motor							
;.equ MOTOR_ABTASTUNG= 0b00000011	; schneller	Motor							
.equ MOTOR_ABTASTUNG= 0b00000111	; Empfehlung								
	SEC  							; Set Carry
	sbis (REFLEX_PIN) ,(REFLEX_PIN_NR)	; Skip if Bit in I/O Register is Set	
	CLC  							; Clear Carry	
	ROL MOTOR_ROHBITS				; C reinschieben
	mov temp,MOTOR_ROHBITS			; Kopie			
	andi temp,(MOTOR_ABTASTUNG)		; Bitmuster		
	cpi  temp,0b00000000			; NULL ?		
	breq TIM0_MOTOR_OK				; OK			
	cpi  temp,(MOTOR_ABTASTUNG)		; Bitmuster	?	
	breq TIM0_MOTOR_OK				; OK			
	rjmp TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
TIM0_MOTOR_OK:
	cp temp,MOTOR_WERT_OLD			; vergleich old	
	breq TIM0_MOTOR_FERTIG			; keine nderug	
; ------------------------------------------------------------------------------
; Impulse werden erkannt (auch Fehlimpulse)										
	mov MOTOR_WERT_OLD,temp			; old save		
	LDS temp,(adr_MOTOR_DREHRICHTUNG); Drehrichtung	
	cpi temp,(0)					; Sillstand ?	
	breq TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; Laufzeit Refresh																
	ldi temp1,(400/2)				; 400ms	
	mov LZ,temp1
; ------------------------------------------------------------------------------
; gltige Impulse																
	cpi temp, (1)					; auf ?		
	breq TIM0_MOTOR_AUF
	cpi temp,(-1)					; zu ?		
	breq TIM0_MOTOR_ZU
	ldi temp1,(ERROR_MOTOR)
	jmp ANZEIGE_ERROR_LEICHT_TEMP1
; ------------------------------------------------------------------------------
TIM0_MOTOR_ZU:
	LDS temp ,(adr_MOTOR_POSITION_IST_L)
	LDS temp1,(adr_MOTOR_POSITION_IST_H)
	sub temp ,EINS
	sbc temp1,NULL
	tst temp1			; berlauf ?
	brpl TIM0_MOTOR_ZU_w
	clr temp
	clr temp1
TIM0_MOTOR_ZU_w:
	STS(adr_MOTOR_POSITION_IST_L),temp
	STS(adr_MOTOR_POSITION_IST_H),temp1
	rjmp TIM0_MOTOR_BERECHNUNG
; ------------------------------------------------------------------------------
TIM0_MOTOR_AUF:
	LDS temp ,(adr_MOTOR_POSITION_IST_L)
	LDS temp1,(adr_MOTOR_POSITION_IST_H)
	cpi temp,255			; berlauf ?
	brne TIM0_MOTOR_w
	cpi temp1,255
 	breq TIM0_MOTOR_AUF_FERTIG
TIM0_MOTOR_w:
	add temp ,EINS
	adc temp1,NULL
	STS(adr_MOTOR_POSITION_IST_L),temp
	STS(adr_MOTOR_POSITION_IST_H),temp1
TIM0_MOTOR_AUF_FERTIG:
; ------------------------------------------------------------------------------
; Ziel erreicht ?																
TIM0_MOTOR_BERECHNUNG:
	LDS temp ,(adr_MOTOR_POSITION_IST_L)	; Vergleich LOW	
	LDS temp1,(adr_MOTOR_POSITION_SOLL_L)
	cp temp1,temp
	brne TIM0_MOTOR_FERTIG
	LDS temp ,(adr_MOTOR_POSITION_IST_H)	; Vergleich HIGH
	LDS temp1,(adr_MOTOR_POSITION_SOLL_H)
	cp temp1,temp
	brne TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; Jaaaa.... hurra  Motor STOP													
	mov LZ,NULL							; Laufeit volle Pulle !
	call MOTOR_STOP
	cbi (LED_PORT),(LED_PIN_NR)				; LED an		
; ------------------------------------------------------------------------------
TIM0_MOTOR_FERTIG:
	out	SREG,KOPIE_SREG		; Wiederherstellen 
	movw temp ,KOPIE_TEMP
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
;CS22 CS21 CS20 																
; 0 0 0 No clock source (timer/counter stopped).								
; 0 0 1 clkT2S/(no prescaling)													
; 0 1 0 clkT2S/8 (from prescaler)												
; 0 1 1 clkT2S/32 (from prescaler)												
; 1 0 0 clkT2S/64 (from prescaler)												
;*1 0 1 clkT2S/128 (from prescaler)												
; 1 1 0 clkT2S/256 (from prescaler)												
; 1 1 1 clkT2S/1024 (from prescaler)											
; 1s / 32.768 Hz																
TIMER2_INITIALISIEREN:
	ldi temp,(1<<TOIE2)
	STS(TIMSK2),temp
	ldi temp,(1<<CS22)|(0<<CS21) |(1<<CS20) 
	STS(TCCR2A),temp
	ldi temp, (1<<AS2)	; Asynchronmodus 32kHz Quarz
	STS(ASSR),temp
;	ldi temp, TIMERWERT2; TIMER2 Startwert		
;	STS(TCNT2),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1s / 32.768 Hz																
TIM2_OVF: 
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; ------------------------------------------------------------------------------
	LDS temp,(adr_SLEEP_TIMER)	; SLEEP TIMER	
	tst temp
	breq PC+2
	dec temp
	STS(adr_SLEEP_TIMER),temp
; ------------------------------------------------------------------------------
	LDS temp,(adr_ss)			; Sekunden	
	inc temp
	STS(adr_ss),temp
	cpi temp,(59+1)
	brlo TIM2_OVF_FERTIG
	STS(adr_ss),NULL

	LDS temp,(adr_mm)			; Minuten	
	inc temp
	STS(adr_mm),temp
	cpi temp,(59+1)
	brlo TIM2_OVF_FERTIG
	STS(adr_mm),NULL

	LDS temp,(adr_hh)			; Stunden	
	inc temp
	STS(adr_hh),temp
	cpi temp,23+1
	brlo TIM2_OVF_FERTIG
	STS(adr_hh),NULL

	LDS temp,(adr_WOCHENTAG)	; WOCHENTAG	
	inc temp
	cpi temp,7+1
	brlo PC+2
	ldi temp,1
	STS(adr_WOCHENTAG),temp
; ------------------------------------------------------------------------------
TIM2_OVF_FERTIG: 
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

