;												
; Heikrperregler THERMOtronic					
; ATmega136										
; Bernhard.Erfurt@gmx.de						
; 11/2017										
;												
;												


; ATmega8 										
.include "m169def.inc"
;												
.equ TAKT					=1000000	;  1 MHz		
.equ U_VBG					=110		; 1,1V			
.equ SLEEP_TIMERWERT		=20
; EEPROM										
.equ EEPROM_WERKSEINSTELLUNG='m'
.equ ANZAHL_EEPROM_BYTES	=100
; ERROR-CODES									
.equ ERROR_INTERRUT			= 0xE0
.equ ERROR_PROGRAMM			= 0xE1
.equ ERROR_EEPROM			= 0xE2
.equ ERROR_MOTOR			= 0xE3
; LED											
.equ LED_PIN_NR				= 4
.equ LED_PIN				= PINF
.equ LED_DDR				= DDRF
.equ LED_PORT				= PORTF
; MOTOR											
.equ MOTOR_AUF_PIN_NR		= 4
.equ MOTOR_AUF_PIN			= PING
.equ MOTOR_AUF_DDR			= DDRG
.equ MOTOR_AUF_PORT			= PORTG
; MOTOR											
.equ MOTOR_ZU_PIN_NR		= 3
.equ MOTOR_ZU_PIN			= PING
.equ MOTOR_ZU_DDR			= DDRG
.equ MOTOR_ZU_PORT			= PORTG
; WIDERSTAND (120k fr Sensor)				
.equ WIDERSTAND_PIN_NR		= 2
.equ WIDERSTAND_DDR			= DDRF
.equ WIDERSTAND_PORT		= PORTF
; TASTE "AM"								
.equ TASTE_AM_WERT			= 1
.equ TASTE_AM_PIN_NR		= 0
.equ TASTE_AM_PIN			= PINB
.equ TASTE_AM_DDR			= DDRB
.equ TASTE_AM_PORT			= PORTB
; TASTE "PROG"								
.equ TASTE_PROG_WERT		= 2
.equ TASTE_PROG_PIN_NR		= 1
.equ TASTE_PROG_PIN			= PINB
.equ TASTE_PROG_DDR			= DDRB
.equ TASTE_PROG_PORT		= PORTB
; TASTE "TEMPERATUR"						
.equ TASTE_TEMPERATUR_WERT	= 4
.equ TASTE_TEMPERATUR_PIN_NR= 2
.equ TASTE_TEMPERATUR_PIN	= PINB
.equ TASTE_TEMPERATUR_DDR	= DDRB
.equ TASTE_TEMPERATUR_PORT	= PORTB
; DREHGEBER									
.equ DREH_A_PIN_NR			= 4
.equ DREH_A_PIN				= PINB
.equ DREH_A_DDR				= DDRB
.equ DREH_A_PORT			= PORTB
; DREHGEBER									
.equ DREH_B_PIN_NR			= 5
.equ DREH_B_PIN				= PINB
.equ DREH_B_DDR				= DDRB
.equ DREH_B_PORT			= PORTB
; REFLEXLICHTSCHRANKE (Input)				
.equ REFLEX_PIN_NR			= 1
.equ REFLEX_PIN				= PINE
.equ REFLEX_DDR				= DDRE
.equ REFLEX_PORT			= PORTE
; REFLEXLICHTSCHRANKE (Power)				
.equ REFLEX_POWER_PIN_NR	= 3
.equ REFLEX_POWER_DDR		= DDRE
.equ REFLEX_POWER_PORT		= PORTE
; REFLEXLICHTSCHRANKE ( extra Power)		
.equ REFLEX_POWERX_PIN_NR	= 2
.equ REFLEX_POWERX_DDR		= DDRE
.equ REFLEX_POWERX_PORT		= PORTE
; REGISTER									

.def LZ					= R4	; Motor Laufzeit	
.def KOPIE_SREG			= R5
.def KOPIE_TEMP			= R6
.def KOPIE_TEMP1		= R7
.def MOTOR_ROHBITS		= R8
.def MOTOR_WERT_OLD		= R9
.def DREHGEBER_ROHBITS	= R10
.def DREHGEBER_WERT_OLD	= R11
.def DREHGEBER_BITMUSTER= R12
.def NULL	 			= R13
.def EINS 				= R14
.def VOLL				= R15
.def temp	 			= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3	 			= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25
; SRAM-BELEGUNG (dier ersten 100Byte werden im EEPROM gespeichert)
.equ adr_DATEN						=SRAM_START+0		; SRAM START Adresse 		
.equ adr_WERKSEINSTELLUNG			=SRAM_START+0

.equ adr_TEMPERATUR_SOLL_L			=SRAM_START+10
.equ adr_TEMPERATUR_SOLL_H			=SRAM_START+11
.equ adr_TEMPERATUR_TAG_L			=SRAM_START+12
.equ adr_TEMPERATUR_TAG_H			=SRAM_START+13
.equ adr_TEMPERATUR_NACHT_L			=SRAM_START+14
.equ adr_TEMPERATUR_NACHT_H			=SRAM_START+15

.equ adr_TEMPERATUR_IST_OFFSET		=SRAM_START+16	; Offset		


.equ adr_MOTOR_POSITION_IST_L		=SRAM_START+20
.equ adr_MOTOR_POSITION_IST_H		=SRAM_START+21
.equ adr_MOTOR_POSITION_ENDE_L		=SRAM_START+22	; Ventil VOLL auf
.equ adr_MOTOR_POSITION_ENDE_H		=SRAM_START+23

.equ adr_TAG1_ON1					=SRAM_START+50 
.equ adr_TAG1_OFF1					=SRAM_START+51 
.equ adr_TAG1_ON2					=SRAM_START+52 
.equ adr_TAG1_OFF2					=SRAM_START+53 
.equ adr_TAG1_ON3					=SRAM_START+54 
.equ adr_TAG1_OFF3					=SRAM_START+55 
.equ adr_TAG2_ON1					=SRAM_START+56 ; TAG-2
.equ adr_TAG2_OFF1					=SRAM_START+57
.equ adr_TAG2_ON2					=SRAM_START+58
.equ adr_TAG2_OFF2					=SRAM_START+59
.equ adr_TAG2_ON3					=SRAM_START+60
.equ adr_TAG2_OFF3					=SRAM_START+61
.equ adr_TAG3_ON1					=SRAM_START+62 ; TAG-3
.equ adr_TAG3_OFF1					=SRAM_START+63
.equ adr_TAG3_ON2					=SRAM_START+64
.equ adr_TAG3_OFF2					=SRAM_START+65
.equ adr_TAG3_ON3					=SRAM_START+66
.equ adr_TAG3_OFF3					=SRAM_START+67
.equ adr_TAG4_ON1					=SRAM_START+68; TAG-4
.equ adr_TAG4_OFF1					=SRAM_START+69
.equ adr_TAG4_ON2					=SRAM_START+70
.equ adr_TAG4_OFF2					=SRAM_START+71
.equ adr_TAG4_ON3					=SRAM_START+72
.equ adr_TAG4_OFF3					=SRAM_START+73
.equ adr_TAG5_ON1					=SRAM_START+74; TAG-5
.equ adr_TAG5_OFF1					=SRAM_START+75
.equ adr_TAG5_ON2					=SRAM_START+76
.equ adr_TAG5_OFF2					=SRAM_START+77
.equ adr_TAG5_ON3					=SRAM_START+78
.equ adr_TAG5_OFF3					=SRAM_START+79
.equ adr_TAG6_ON1					=SRAM_START+80 ; TAG-6
.equ adr_TAG6_OFF1					=SRAM_START+81
.equ adr_TAG6_ON2					=SRAM_START+82
.equ adr_TAG6_OFF2					=SRAM_START+83
.equ adr_TAG6_ON3					=SRAM_START+84
.equ adr_TAG6_OFF3					=SRAM_START+85
.equ adr_TAG7_ON1					=SRAM_START+86 ; TAG-7
.equ adr_TAG7_OFF1					=SRAM_START+87
.equ adr_TAG7_ON2					=SRAM_START+88
.equ adr_TAG7_OFF2					=SRAM_START+89
.equ adr_TAG7_ON3					=SRAM_START+90
.equ adr_TAG7_OFF3					=SRAM_START+91
;-------------------------------------------------------------------------------
.equ adr_ss							=SRAM_START+100	; Sekunden					
.equ adr_mm							=SRAM_START+101	; Minuten					
.equ adr_hh							=SRAM_START+102	; Stunden					
.equ adr_TAG						=SRAM_START+103	; TAG						
.equ adr_WOCHENTAG					=SRAM_START+104	; Wochentag (1=Mo 7=So)		

.equ adr_MENUE						=SRAM_START+110
.equ adr_TASTE						=SRAM_START+111
.equ adr_TASTE_OLD					=SRAM_START+112

.equ adr_DREHGEBER_WERT				=SRAM_START+120	; (0=NIX) (1=Richtung_1) (255=Richtung_2)	

.equ adr_ZEITPROGRAMM_GRUPPE		=SRAM_START+122 ; fr Programmierung Heizzeiten				

.equ adr_SLEEP_TIMER				=SRAM_START+124
.equ adr_TIMER_BARGRAPH				=SRAM_START+125
.equ adr_MODUS_MANU_ON				=SRAM_START+126		; AUTOMATIC					

.equ adr_TESTWERT_L					=SRAM_START+130
.equ adr_TESTWERT_H					=SRAM_START+131

.equ adr_MOTOR_DREHRICHTUNG			=SRAM_START+180
.equ adr_MOTOR_POSITION_SOLL_L		=SRAM_START+181
.equ adr_MOTOR_POSITION_SOLL_H		=SRAM_START+182

.equ adr_TEMPERATUR_IST_L			=SRAM_START+190	; IST_Temperatur	
.equ adr_TEMPERATUR_IST_H			=SRAM_START+191
.equ adr_TEMPERATUR_IST_SYSOFFS_L	=SRAM_START+192	; System-Offset		
.equ adr_TEMPERATUR_IST_SYSOFFS_H	=SRAM_START+193
.equ adr_TEMPERATUR_IST_STEIGUNG_L	=SRAM_START+194	; System-Steigung	
.equ adr_TEMPERATUR_IST_STEIGUNG_H	=SRAM_START+195

.equ adr_MOMENTAN_ON1				=SRAM_START+200 ; ON- 1.Schaltpunkt	
.equ adr_MOMENTAN_OFF1				=SRAM_START+201 ; OFF-1.Schaltpunkt	
.equ adr_MOMENTAN_ON2				=SRAM_START+202 ; ON- 2.Schaltpunkt	
.equ adr_MOMENTAN_OFF2				=SRAM_START+203 ; OFF-2.Schaltpunkt	
.equ adr_MOMENTAN_ON3				=SRAM_START+204 ; ON- 3.Schaltpunkt	
.equ adr_MOMENTAN_OFF3				=SRAM_START+205 ; OFF-3.Schaltpunkt	

.equ adr_LCD0						=SRAM_START+240	; LCD-DIGIT-0 
.equ adr_LCD1						=SRAM_START+241	; LCD-DIGIT-1 
.equ adr_LCD2						=SRAM_START+242	; LCD-DIGIT-2 
.equ adr_LCD3						=SRAM_START+243	; LCD-DIGIT-3 

.equ adr_ADC_0_L					=SRAM_START+250
.equ adr_ADC_0_H					=SRAM_START+251
.equ adr_ADC_1_L					=SRAM_START+252
.equ adr_ADC_1_H					=SRAM_START+253
.equ adr_ADC_2_L					=SRAM_START+254
.equ adr_ADC_2_H					=SRAM_START+255
.equ adr_ADC_3_L					=SRAM_START+256
.equ adr_ADC_3_H					=SRAM_START+257
.equ adr_ADC_4_L					=SRAM_START+258
.equ adr_ADC_4_H					=SRAM_START+259
.equ adr_ADC_5_L					=SRAM_START+260
.equ adr_ADC_5_H					=SRAM_START+261
.equ adr_ADC_6_L					=SRAM_START+262
.equ adr_ADC_6_H					=SRAM_START+263
.equ adr_ADC_7_L					=SRAM_START+264
.equ adr_ADC_7_H					=SRAM_START+265
.equ adr_ADC_VBG_L					=SRAM_START+266
.equ adr_ADC_VBG_H					=SRAM_START+267


.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein




.cseg							;Beginn eines Code-Segmentes						
.org 0							;Startadresse=0										
.org 0x0000 jmp RESET 			; Reset Handler										
.org 0x0002 jmp INTERRUPT_ERROR ; jmp EXT_INT0 	; IRQ0 Handler						
.org 0x0004 jmp INTERRUPT_ERROR ; jmp PCINT0 		; PCINT0 Handler				
.org 0x0006 jmp INTERRUPT_ERROR ; jmp PCINT1 		; PCINT0 Handler				
.org 0x0008 jmp INTERRUPT_ERROR ; jmp TIM2_COMP 	; Timer2 Compare Handler		
.org 0x000A jmp TIM2_OVF 	; Timer2 Overflow Handler								
.org 0x000C jmp INTERRUPT_ERROR ; jmp TIM1_CAPT 	; Timer1 Capture Handler		
.org 0x000E jmp INTERRUPT_ERROR ; jmp TIM1_COMPA 	; Timer1 CompareA Handler		
.org 0x0010 jmp INTERRUPT_ERROR ; jmp TIM1_COMPB 	; Timer1 CompareB Handler		
.org 0x0012 jmp INTERRUPT_ERROR ; jmp TIM1_OVF 	; Timer1 Overflow Handler			
.org 0x0014 jmp INTERRUPT_ERROR ; jmp TIM0_COMP 	; Timer0 Compare Handler		
.org 0x0016 jmp TIM0_OVF 	; Timer0 Overflow Handler								
.org 0x0018 jmp INTERRUPT_ERROR ; jmp SPI_STC 	; SPI Transfer Complete Handler		
.org 0x001A jmp INTERRUPT_ERROR ; jmp USART_RXCn 	; USART0 RX Complete Handler	
.org 0x001C jmp INTERRUPT_ERROR ; jmp USART_DRE 	; USART0,UDRn Empty Handler		
.org 0x001E jmp INTERRUPT_ERROR ; jmp USART_TXCn 	; USART0 TX Complete Handler	
.org 0x0020 jmp INTERRUPT_ERROR ; jmp USI_STRT 	; USI Start Condition Handler		
.org 0x0022 jmp INTERRUPT_ERROR ; jmp USI_OVFL 	; USI Overflow Handler				
.org 0x0024 jmp INTERRUPT_ERROR ; jmp ANA_COMP 	; Analog Comparator Handler			
.org 0x0026 jmp INTERRUPT_ERROR ; jmp ADC 		; ADC Conversion Complete Handler	
.org 0x0028 jmp INTERRUPT_ERROR ; jmp EE_RDY 		; EEPROM Ready Handler			
.org 0x002A jmp INTERRUPT_ERROR ; jmp SPM_RDY 	; SPM Ready Handler					
.org 0x002C jmp INTERRUPT_ERROR ; jmp LCD_SOF 	; LCD Start of Frame Handler		
;-------------------------------------------------------------------------------
INTERRUPT_ERROR:
	ldi temp1,(ERROR_INTERRUT)
	rjmp ANZEIGE_ERROR_SCHWER_TEMP1
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
;-------------------------------------------------------------------------------
	call WDR_INITIALISIERUNG
	call PORT_CLEAR
	call REGISTER_CLEAR
	call SRAM_CLEAR
	call STARTWERTE
	call TIMER0_INITIALISIEREN
	call TIMER2_INITIALISIEREN
	call LCD_INITIALISIERUNG
	call NEUSTART_MIT_WDR		; Neustart
	call EEPROM_KONFIGURATION_LADEN
	call LED_INITIALISIERUNG
	call ADC_INITIALISIERUNG
	call MOTOR_INITIALISIERUNG
	call TASTEN_INITIALISIEREN
	call DREHGEBER_INITIALISIEREN
	call SLEEP_INITIALISIEREN
	call PROGRAMM_CHECK
;-------------------------------------------------------------------------------
	SEI
	call LCD_VOLL	
	call PROGRAMM_CHECK
	call MOTOR_BEEP
	call WAIT_100ms
	call MOTOR_BEEP
	call LCD_CLEAR

	call MOTOR_POSITION_NULL

	ldi XL,LOW (100)
	ldi XH,HIGH(100)
	call MOTOR_NACH_X

;-------------------------------------------------------------------------------
LOOP:
	WDR
	call MENUE
	call PROGRAMM_CHECK
	call REFRESH
	;call BERECHNUNG_SLEEP
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
REFRESH:
	LDS temp,(adr_MENUE)		
	tst temp
	breq REFRESH_RUN
ret
;-------------------------------------------------------------------------------
REFRESH_RUN:
	LDS temp,(adr_MODUS_MANU_ON)
	tst temp
	brne REFRESH_AUTO
REFRESH_MANU:
	call FUNCTION_HEIZZEITEN_LADEN
	ret
REFRESH_AUTO:
	call FUNCTION_HEIZZEITEN_AUS

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_SLEEP:
	LDS temp,(adr_SLEEP_TIMER)
	tst temp 
	breq BERECHNUNG_SLEEP_RUN
	WDR
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_SLEEP_RUN:
	WDR
	SLEEP
	WDR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "H_ADC.asm"
.include "H_EEPROM.asm"
.include "H_LCD_DEF.asm"
.include "H_LCD.asm"
.include "H_LCD_ANZEIGE.asm"
.include "H_LCD_BARGRAPH.asm"
.include "H_LCD_TEXT.asm"
.include "H_MENUE.asm"
.include "H_MOTOR.asm"
.include "H_TASTEN.asm"
.include "H_TIMER.asm"
.include "H_SONSTIGES.asm"
.include "H_WAIT_01MHZ.asm"




